import sys


def error(msg: str):
    msg = "Required Python packages could not be found:\n" + msg
    print(msg, file=sys.stderr)
    sys.exit(1)


print("Checking Python environment - ", end="")

try:
    import pystencils
except ImportError:
    error("pystencils is not installed in the current Python environment.")

try:
    import pystencilssfg
except ImportError:
    error("pystencils-sfg is not installed in the current Python environment.")

try:
    import walberla.codegen
except ImportError:
    error("walberla-codegen is not installed in the current Python environment.")

print("found required packages pystencils, pystencils-sfg, sfg-walberla", end="")

sys.exit(0)
