(ForceDrivenChannel)=
# Force-Driven Poiseuille Channel

This example aims to illustrate the basic code generation features of `sfg-walberla`
by building a force-driven channel flow application.

## Files

{download}`ForceDrivenChannel.zip </zipped-examples/ForceDrivenChannel.zip>`.

This example comprises the following files:

 - `ForceDrivenChannel.cpp`: The main simulation application;
 - `LbmAlgorithms.py`: The code generation script producing the lattice Boltzmann algorithms;
 - `CMakeLists.txt`: The CMake build system configuration;
 - `Channel.prm`: the parameter file describing the channel.


## CMake Target Definition

:::{card} `CMakeLists.txt`
::::{literalinclude} CMakeLists.txt
:language: CMake
::::
:::

The CMake target setup for this example is quite straight-forward.
We create a new executable called `Ex_ForceDrivenChannel`
and add to it the single C++ source file `ForceDrivenChannel.cpp`.
Then, we register our code generator script `LbmAlgorithms.py` via the
`walberla_generate_sources` CMake function.
