from pystencilssfg import SourceFileGenerator
from walberla.codegen import Sweep
from walberla.codegen.symbolic import cell
from pystencils import fields, Assignment, CreateKernelConfig, Target

with SourceFileGenerator() as sfg:
    sfg.namespace("SparseSpiral::gen")
    f = fields("f(3): double[3D]", layout="fzyx")

    asms = [
        Assignment(f.center(0), cell.x()),
        Assignment(f.center(1), cell.y()),
        Assignment(f.center(2), cell.z()),
    ]

    cfg = CreateKernelConfig(target=Target.GenericCPU)

    sweep = Sweep("SpiralSweep", asms, cfg)
    sweep.sparse = True

    sfg.generate(sweep)
