# WaLBerla Code Generation Development Project

Welcome to the `sfg-walberla` project,
where the next generation of code generators for waLBerla is being developed.
These are based on bleeding-edge developments in
[pystencils 2.0][pystencils_2_0] and [pystencils-sfg][pystencils-sfg].
This project is still unstable and immature, but growing steadily.

In this user manual, you will find guidance and information about how to use the new
code generation infrastructure in your simulation applications.

## Table of Contents

:::{toctree}
:caption: Fundamentals
:maxdepth: 1

CMakeSetup/CMakeSetup
examples/GeneratorScriptBasics/GeneratorScriptBasics
:::

:::{toctree}
:caption: User Guides
:maxdepth: 1

guides/SparseSweeps
guides/BoundaryConditions
:::

:::{toctree}
:caption: Examples
:maxdepth: 1

examples/ForceDrivenChannel/ForceDrivenChannel
:::

:::{toctree}
:caption: Reference
:maxdepth: 1

reference/PystencilsLanguageExtensions
reference/PythonEnvironment
:::


[pystencils_2_0]: https://da15siwa.pages.i10git.cs.fau.de/dev-docs/pystencils-nbackend/ "pystencils 2.0 Documentation"
[pystencils-sfg]: https://pycodegen.pages.i10git.cs.fau.de/pystencils-sfg/index.html "pystencils-sfg Documentation"
[sfg-walberla]: https://i10git.cs.fau.de/da15siwa/sfg-walberla "SFG-waLBerla Repository"
